#include "ruter.h"

using namespace std;

extern Stoppesteder* gStoppesteder;

Ruter::Ruter() {
}

Ruter::~Ruter() {
}

void Ruter::ny(const int& nr) {
    cout << "\nBuss eller bane?" << '\n'
         << "\n1 - Buss" << '\n'
         << "2 - Bane" << '\n'
         << "0 - Avbryt" << '\n';

    switch (lesInt("", 0, 2)) {
        case 0:
            break;
        case 1: {
            Buss* buss = new Buss;
            if (buss->ny(-1, -1) != nullptr)
                alleRuter.insert(pair<int, Rute*>(nr, buss));
            break;
        }
        case 2: {
            Bane* bane = new Bane;
            if (bane->ny(-1, -1) != nullptr)
                alleRuter.insert(pair<int, Rute*>(nr, bane));
            break;
        }
        default:
            cout << "\nUlovlig valg!" << '\n';
            break;
    }
}

Rute* Ruter::hentEksisterende(const int nr) {
    // for (const auto & val : alleRuter)
    Rute* rute = nullptr;
    for_each(begin(alleRuter), end(alleRuter),
             [&rute, &nr](pair<int const, Rute*>& mRuter) {
                 if (mRuter.first == nr) rute = mRuter.second;
             });
    /*const auto & it = find_if(alleRuter.begin(), alleRuter.end(),
    [nr](map<int, Rute*>mRuter){return true; });
    it.first == 1;*/
    return rute;
}

void Ruter::skrivMeny() {
    /*cout << "\n1 - Buss" << '\n'
    << "2 - Bane" << '\n'
    << "0 - Avbryt" << '\n';*/
    cout << "\nN - Ny rute" << '\n'
         << "A - Skriv kort alle ruter" << '\n'
         << "E - Endre rute" << '\n'
         << "B - Rute beskrivelse" << '\n'
         << "T - Rutetabell" << '\n'
         << "Q - Tilbake" << '\n';
}

void Ruter::meny(const char& valg) {
    // char valg;
    Rute* rute;
    int ruteNr;

    // do {
    rute = nullptr;
    ruteNr = -1;
    // skrivMeny();
    // valg = lesChar("");
    switch (valg) {
        case 'N': {
            ruteNr = lesRute();
            rute = hentEksisterende(ruteNr);
            if (rute == nullptr) {
                ny(ruteNr);
            } else
                cout << "\nError: Rute eksisterer allerede!" << '\n';

            break;
        }
        case 'A':
            skrivKortData();
            break;
        case 'E':
            endre();
            break;
        case 'B':
            ruteNr = lesRute();
            spesifikkRuteData(ruteNr);
            break;
        case 'T':
            ruteNr = lesRute();
            rute = hentEksisterende(ruteNr);
            if (rute != nullptr) {
                rute->tabell();
            } else
                cout << "\nError: Rute eksisterer ikke!" << '\n';
            break;
        case 'Q':
            break;
        default:
            cout << "\nUgyldig valg!" << '\n';
            break;
    }
    //} while (valg != 'Q');

    /* Rute* rute;
    int valg, ruteNr;
    ruteNr = lesInt("Skriv inn nummer for ny rute", MIN_RUTER, MAX_RUTER);
    skrivMeny();
    valg = lesInt("", 0, 3);
    rute = hentEksisterende(ruteNr);
    if (rute == nullptr) {
        ny(valg, ruteNr);
    } else
        cout << "\nError: Rute eksisterer allerede!" << '\n';*/
}

void Ruter::skrivKortData() {  // skrivKortData
    Buss* buss;
    Bane* bane;
    Stoppested* stopp;
    cout << "\nRute nummer\tType\tEndestasjon";
    for (const auto& val : alleRuter) {
        stopp = nullptr;
        cout << "\nRute nr:" << val.first;
        /*if (val.second == buss)
            cout << "\tBuss";
        else
            cout << "\tBane";*/
        cout << '\t';
        val.second->skrivType();
        if (val.second->alleStoppestedenePaaRuten.size() > 0) {
            stopp = gStoppesteder->hentEksisterende(
                val.second->alleStoppestedenePaaRuten.back()->indexStoppested);
        }
        if (stopp != nullptr) cout << "\t" << stopp->hentNavn();
    }
}

void Ruter::skrivData(Rute* rute) {
    rute->skrivData();
}

void Ruter::spesifikkRuteData(const int& ruteNr) {
    Rute* rute;
    // int ruteNr;
    // ruteNr = lesRute();
    rute = hentEksisterende(ruteNr);
    if (rute != nullptr) {
        // skrivData(rute);
        rute->skrivData();
    } else
        cout << "\nError: rute nr: " << ruteNr << " finnes ikke!" << '\n';
}

void Ruter::endre() {
    Rute* rute;
    int ruteNr, valg;
    ruteNr = lesRute();
    rute = hentEksisterende(ruteNr);
    if (rute != nullptr) {
        spesifikkRuteData(ruteNr);
        rute->endre();
    } else
        cout << "\nError: rute nr: " << ruteNr << " finnes ikke!" << '\n';

    if (valg > 0) {
        /* int start, slutt;
         start = lesInt("Hvilke stoppested utgjør start ytterpunkt?",
                        1, alleStoppestedenePaaRuten.size());
         slutt = lesInt("Hvilket stoppested utgjør slutt ytterpunkt?",
                        start + 1, alleStoppestedenePaaRuten.size());*/
    }
}

int Ruter::lesRute() {
    int ruteNr;
    ruteNr = lesInt("Skriv inn rute nummer", MIN_RUTER, MAX_RUTER);
    return ruteNr;
}